# /webmail/refile-selected.tcl
# by jsc@arsdigita.com (2000-02-23)

# Perform bulk refiling of selected messages.

ad_page_variables {mailbox_id}

validate_integer mailbox_id $mailbox_id

set user_id [ad_verify_and_get_user_id]

set db [ns_db gethandle]

set msg_ids [ad_get_client_property "webmail" "selected_messages"]


if { [database_to_tcl_string $db "select count(*)
from wm_mailboxes
where mailbox_id = $mailbox_id
  and creation_user = $user_id"] == 0 } {
    ad_return_error "Permission Denied" "You do not have permission to refile to this mailbox."
    ns_log Notice "WEBMAIL WARNING: user $user_id attempted to refile messages to mailbox $mailbox_id"
    return
}

with_catch errmsg {
    ns_db dml $db "update wm_message_mailbox_map
set mailbox_id = $mailbox_id
 where msg_id in ([join $msg_ids ", "])
  and mailbox_id in (select mailbox_id from wm_mailboxes where creation_user = $user_id)"
} {
    ad_return_error "Refiling Failed" "Refiling of messages failed:
<pre>
$errmsg
</pre>
"
    return
}

ns_returnredirect "index.tcl"

